variables:
  JMETER_REPO: "registry.gitlab.com/rs-devsecops/rs-dev/ci-build/jmeter"
  JMETER_TAG: "${JMETER_REPO}:0.20190905142220.201ef0ac"
  JMETER_DIGEST: "sha256:3b2530b3bb70321dc2f8639b66eb80a615dba980babe2298ffd34e447077082b"
  JMETER_IMAGE_WITH_DIGEST: ${JMETER_REPO}@${JMETER_DIGEST}
  DATADOG_URL: https://app.datadoghq.com

.jmeter:serverside-performance:
  variables:
    JMETER_MAX_ALLOWABLE_ERR_RATE_PERCENT: 5
    JMETER_MAX_ALLOWABLE_AVG_RESPONSE_TIME_MS: 500
    JMETER_TEST_DOMAIN: "https://st1-ie.rs-online.com/web/"
    JMETER_CONFIG_FILE: "test/my-account-service-test.jmx"
    JMETER_EXTRA_PARAMETERS: '-l results.jtl'
    PUSH_TO_DATADOG: "false"
  extends: .base
  image: ${JMETER_IMAGE_WITH_DIGEST}
  script:
#      Always use Non-GUI mode (-n) and specify the jmx test file location (-t)
    - |
      echo ${JMETER_TEST_DOMAIN}
      echo ${JMETER_CONFIG_FILE}
      echo ${JMETER_EXTRA_PARAMETERS}

      date +%s000 > start.txt
      jmeter -n -t ${JMETER_CONFIG_FILE}  ${JMETER_EXTRA_PARAMETERS} -JJMETER_TEST_DOMAIN=${JMETER_TEST_DOMAIN}
      date +%s000 > end.txt
      java -jar /opt/apache-jmeter-3.3/lib/cmdrunner-2.0.jar --tool Reporter --generate-csv summary.csv --input-jtl "results.jtl" --plugin-type SynthesisReport
      echo "Summary results generated with content - "
      cat summary.csv
      echo "Checking results against max allowable values"
      python /usr/bin/pass_fail_jmeter_summary.py summary.csv ${JMETER_MAX_ALLOWABLE_AVG_RESPONSE_TIME_MS} ${JMETER_MAX_ALLOWABLE_ERR_RATE_PERCENT}
  after_script:
    - >
      if [ "PUSH_TO_DATADOG" == "true" ]; then
        echo "Reading datadog credentials from vault..."
        VAULT_RESPONSE=$(vault kv get -format json secret/shared/datadog-pipeline)
        export DATADOG_API_KEY=$(echo $VAULT_RESPONSE | jq -r .data.api_key)
        export DATADOG_APP_KEY=$(echo $VAULT_RESPONSE | jq -r .data.app_key)
        unset VAULT_RESPONSE
        echo "Uploading stats to datadog"
        python /usr/bin/push-metrics-to-datadog.py results.jtl
        echo "******************************"
        echo "Visit DataDog dashboard to see JMeter test results:"
        echo "- $DATADOG_URL/metric/explorer?live=false&page=0&is_auto=false&from_ts=$(cat start.txt)&to_ts=$(cat end.txt)&tile_size=m&exp_metric=jmeter.transaction.elapsed%2Cjmeter.transaction.bytes%2Cjmeter.transaction.latency%2Cjmeter.transaction.response_code&exp_scope=gitlab_job_id%3A${CI_JOB_ID}&exp_agg=avg&exp_row_type=metric"
        echo "******************************"
      else
        echo "Push results to datadog is disabled"
      fi
  artifacts:
    name: jmeter-test-report
    expire_in: 31d
    when: always
    paths: [results.jtl,jmeter.log,summary.csv]

